SystemOrganization addCategory: #ConfigurationOfResourceImporter!

Object subclass: #ConfigurationOfResourceImporter
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfResourceImporter'!

!ConfigurationOfResourceImporter class methodsFor: 'development support' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfResourceImporter class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfResourceImporter class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfResourceImporter class methodsFor: 'private' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfResourceImporter class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfResourceImporter class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfResourceImporter class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfResourceImporter class methodsFor: 'loading' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfResourceImporter class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
project

	^self new project! !

!ConfigurationOfResourceImporter class methodsFor: 'development support' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfResourceImporter methodsFor: 'baselines' stamp: 'HernanMoralesDurand 10/22/2013 21:21'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/ResourceImporter/main'.
		spec project: 'CodeGenerator' with: [ 
			spec
				className: 'ConfigurationOfCodeGenerator';
				file: 'ConfigurationOfCodeGenerator';
				version: #stable;
				repository: 'http://www.smalltalkhub.com/mc/hernan/CodeGenerator/main' ].
		spec project: 'InstanceEncoder' with: [ 
			spec
				className: 'ConfigurationOfInstanceEncoder';
				file: 'ConfigurationOfInstanceEncoder';
				version: #stable;
				repository: 'http://www.smalltalkhub.com/mc/hernan/InstanceEncoder/main' ].	
		spec package: 'LibraryImporter' with: [ spec requires: #('CodeGenerator' 'InstanceEncoder') ].
		spec group: 'default' with: #('LibraryImporter' ). ].
! !

!ConfigurationOfResourceImporter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfResourceImporter methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 10/22/2013 20:58'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfResourceImporter methodsFor: 'accessing' stamp: 'HernanMoralesDurand 8/22/2013 02:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfResourceImporter methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 10/22/2013 20:58'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfResourceImporter methodsFor: 'versions' stamp: 'HernanMoralesDurand 8/22/2013 02:10'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '8/22/2013 02:05'.
		spec package: 'LibraryImporter' with: 'LibraryImporter-HernanMoralesDurand.14'. ].
! !

!ConfigurationOfResourceImporter methodsFor: 'versions' stamp: 'HernanMoralesDurand 10/22/2013 20:58'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: ''.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '10/22/2013 02:05'.
		spec package: 'LibraryImporter' with: 'LibraryImporter-HernanMoralesDurand.16'. ].
! !
